Rygel.SimpleContainer – librygel-server Reference Manual

# SimpleContainer

## Object Hierarchy:

## Description:

public class SimpleContainer : MediaContainer, SearchableContainer

A simple implementation of RygelMediaContainer that keeps all RygelMediaObjects in memory. You should add children via rygel_simple_container_add_child_item().

Namespace: Rygel
Package: librygel-server

## Content:

### Properties:

- public ArrayList<string> search_classes { set; get; }

### Creation methods:

- public SimpleContainer (string id, MediaContainer? parent, string title)
  Creates a child RygelSimpleContainer.
- public SimpleContainer.root (string title)
  Creates a RygelSimpleContainer as a root container.

### Methods:

- public override void constructed ()
- public void add_child_item (MediaItem child)
  Adds an item to the container.
- protected MediaObjects get_all_children ()
  Get all children, including the empty children.
- public void add_child_container (MediaContainer child)
  Adds a child container to this container.
- public void remove_child (MediaObject child)
  Removes the item from the container.
- public void clear ()
  Removes all child items and child containers from the container.
- protected bool is_child_id_unique (string child_id)
  Check that the ID is unique within this container.
- public override async MediaObjects? get_children (uint offset, uint max_count, string sort_criteria, Cancellable? cancellable) throws Error
- public override async MediaObject? find_object (string id, Cancellable? cancellable) throws Error
- public async MediaObjects? search (SearchExpression? expression, uint offset, uint max_count, string sort_criteria, Cancellable? cancellable, out uint total_matches) throws Error

### Fields:

- public MediaObjects children

### Inherited Members:

All known members inherited from class Rygel.MediaContainer

- ANY
- UPNP_CLASS
- STORAGE_FOLDER
- MUSIC_ALBUM
- MUSIC_ARTIST
- MUSIC_GENRE
- PLAYLIST
- ALBUM_SORT_CRITERIA
- child_count

- empty_child_count
- all_child_count
- create_mode_enabled
- sort_criteria
- ocm_flags
- equal_func
- constructed
- get_children
- find_object

- updated
- serialize
- create_stream_source_for_resource
- container_updated
- sub_tree_updates_finished
- update_id
- storage_used
- total_deleted_child_count

All known members inherited from class Rygel.MediaObject

- id
- ref_id
- upnp_class
- date
- creator
- modified
- object_update_id
- artist
- genre
- parent

- parent_ref
- title
- ocm_flags
- apply_replacements
- get_uris
- get_primary_uri
- add_uri
- constructed
- get_writable

- get_writables
- get_resource_list
- get_resource_by_name
- serialize
- serialize_resource_list
- create_stream_source_for_resource
- compare_string_props
- compare_int_props
- parent_ptr

All known members inherited from class GLib.Object

- interface_find_property
- interface_install_property
- interface_list_properties
- @new
- new_valist
- newv
- new_with_properties
- add_toggle_ref
- add_weak_pointer
- bind_property
- connect
- constructed
- disconnect
- dispose
- dup_data
- dup_qdata
- force_floating

- freeze_notify
- @get
- get_class
- get_data
- get_property
- get_qdata
- get_type
- getv
- is_floating
- notify_property
- @ref
- ref_sink
- replace_data
- replace_qdata
- remove_toggle_ref
- remove_weak_pointer
- @set

- set_data
- set_data_full
- set_property
- set_qdata
- set_qdata_full
- set_valist
- setv
- steal_data
- steal_qdata
- thaw_notify
- unref
- watch_closure
- weak_ref
- weak_unref
- notify
- ref_count

All known members inherited from interface Rygel.SearchableContainer

- search_classes
- search

- simple_search

- find_object